// This file provides networking using hyper (which
// https://gitlab.torproject.org/onyinyang/lox-server uses).

use hyper::{Body, Client, Method, Request};

pub async fn net_request(url: String, body: Vec<u8>) -> Vec<u8> {
    let client = Client::new();

    let uri: hyper::Uri = url.parse().expect("Failed to parse URL");

    // always POST even if body is empty
    let req = Request::builder()
        .method(Method::POST)
        .uri(uri)
        .body(Body::from(body))
        .expect("Failed to create POST request");
    let resp = client.request(req).await.expect("Failed to POST");

    println!("Response: {}", resp.status());

    let buf = hyper::body::to_bytes(resp)
        .await
        .expect("Failed to concat bytes");
    buf.to_vec()
}
